package com.mm.controller.rest;

import com.mm.domen.Kupac;
import com.mm.domen.KupacPravnoLice;
import com.mm.domen.Mesto;
import com.mm.service.KupacService;
import com.mm.service.MestoService;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 * @author Milos Milic
 */
@RestController
@RequestMapping("/kupac")
public class KupacRestController {

    @Autowired
    private KupacService kupacService;

    @Autowired
    private MestoService mestoService;

    @RequestMapping(value = "/all", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Object findAll() {
        List<Kupac> kupci = kupacService.findAll();
        return ResponseEntity.status(HttpStatus.OK).body(kupci);
    }

    @RequestMapping(value = "/get/{id}", method = RequestMethod.GET)
    public @ResponseBody Object get(@PathVariable Long id) {
        Kupac k = kupacService.findByID(id);
        return ResponseEntity.status(HttpStatus.OK).body(k);
    }

    @RequestMapping(value = "/delete/{id}", method = RequestMethod.DELETE, produces = MediaType.TEXT_PLAIN_VALUE)
    public @ResponseBody Object delete(@PathVariable Long id) {
        kupacService.delete(id);
        return ResponseEntity.status(HttpStatus.OK).body("Deleted");
    }

    @RequestMapping(value = "/pravno/save", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Object savePravno(@RequestBody KupacPravnoLice k) {
        Mesto m = mestoService.findByPtt(k.getMesto().getPtt());
        k.setMesto(m);
        KupacPravnoLice kupacPravnoLice = (KupacPravnoLice) kupacService.save(k);
        return ResponseEntity.status(HttpStatus.OK).body(kupacPravnoLice);
    }
}
