/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mm.controller.rest;

import com.mm.domen.Mesto;
import com.mm.service.MestoService;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 * @author student
 */
@RestController
@RequestMapping("/mesto")
public class MestoRestController {

    @Autowired
    private MestoService mestoService;

    @RequestMapping(value = "/all", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Object getAll() {
        List<Mesto> list = mestoService.findAll();
        return ResponseEntity.status(HttpStatus.OK).body(list);
    }

    @RequestMapping(value = "/get/{id}", method = RequestMethod.GET)
    public @ResponseBody Object get(@PathVariable Long id) {
        Mesto m = mestoService.findByPtt(id);
        return ResponseEntity.status(HttpStatus.OK).body(m);
    }

    @RequestMapping(value = "/delete/{id}", method = RequestMethod.DELETE, produces = MediaType.TEXT_PLAIN_VALUE)
    public @ResponseBody Object delete(@PathVariable Long id) {
        mestoService.delete(id);
        return ResponseEntity.status(HttpStatus.OK).body("Deleted");
    }

    @RequestMapping(value = "/save", method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody Object save(@RequestBody Mesto m) {
        Mesto mesto = mestoService.save(m);
        return ResponseEntity.status(HttpStatus.OK).body(mesto);
    }

}
