package com.mm.controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.web.authentication.logout.SecurityContextLogoutHandler;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

/**
 *
 * @author Milos Milic
 */
@Controller
public class HomeController {

    @RequestMapping("/")
    public ModelAndView start() {
        return new ModelAndView("prijavi_se.jsp");
    }

    @RequestMapping(value = "/action/start", method = RequestMethod.GET)
    public ModelAndView login(HttpServletRequest request) {
        return new ModelAndView("/WEB-INF/pocetna.jsp");
    }

    @RequestMapping(value = "/action/izloguj_se", method = RequestMethod.GET)
    public ModelAndView logut(HttpServletRequest request, HttpServletResponse response) {
        Authentication auth = SecurityContextHolder.getContext().getAuthentication();
        if (auth != null) {
            new SecurityContextLogoutHandler().logout(request, response, auth);
        }
        return new ModelAndView("/prijavi_se.jsp");
    }
}
