package com.mm.security;

import com.mm.domen.User;
import java.util.Collection;
import java.util.List;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.GrantedAuthority;

/**
 *
 * @author Milos Milic
 */
public class TokenUser implements Authentication {

    private final User user;
    private boolean isAuth;
    private String token;
    private List<GrantedAuthority> grantedAuthorities;

    public TokenUser(User user, List<GrantedAuthority> grantedAuthorities, String token) {
        super();
        this.user = user;
        this.grantedAuthorities = grantedAuthorities;
        this.token = token;
    }

    public boolean isIsAuth() {
        return isAuth;
    }

    public void setIsAuth(boolean isAuth) {
        this.isAuth = isAuth;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public List<GrantedAuthority> getGrantedAuthorities() {
        return grantedAuthorities;
    }

    public void setGrantedAuthorities(List<GrantedAuthority> grantedAuthorities) {
        this.grantedAuthorities = grantedAuthorities;
    }

    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        return grantedAuthorities;
    }

    @Override
    public Object getCredentials() {
        return null;
    }

    @Override
    public Object getDetails() {
        return user;
    }

    @Override
    public boolean isAuthenticated() {
        return isAuth;
    }

    @Override
    public void setAuthenticated(boolean bln) throws IllegalArgumentException {
        this.isAuth = bln;
    }

    @Override
    public Object getPrincipal() {
        return user.getUsername();
    }

    @Override
    public String getName() {
        return user.getUsername();
    }

}
